package cn.iocoder.yudao.module.mes.service.producereport;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportDetailRespVO;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportPageReqVO;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportRespVO;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportSaveReqVO;
import cn.iocoder.yudao.module.mes.dal.dataobject.producereport.ProduceReportDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.producereport.ProduceReportDetailDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.producereport.ViewReportUserDateSummary;

import javax.validation.Valid;
import java.util.List;

/**
 * 生产报工单 Service 接口
 *
 * @author 内蒙必硕
 */
public interface ProduceReportService {

    /**
     * 创建生产报工单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProduceReport(@Valid ProduceReportSaveReqVO createReqVO);

    /**
     * 更新生产报工单
     *
     * @param updateReqVO 更新信息
     */
    void updateProduceReport(@Valid ProduceReportSaveReqVO updateReqVO);

    /**
     * 删除生产报工单
     *
     * @param id 编号
     */
    void deleteProduceReport(Long id);

    /**
     * 获得生产报工单
     *
     * @param id 编号
     * @return 生产报工单
     */
    ProduceReportDO getProduceReport(Long id);

    /**
     * 获得生产报工单分页
     *
     * @param pageReqVO 分页查询
     * @return 生产报工单分页
     */
    PageResult<ProduceReportDO> getProduceReportPage(ProduceReportPageReqVO pageReqVO);
    List<ProduceReportRespVO> buildVOList(List<ProduceReportDO> list);
    // ==================== 子表（生产报工明细） ====================

    /**
     * 获得生产报工明细列表
     *
     * @param reportId 报工单id
     * @return 生产报工明细列表
     */
    List<ProduceReportDetailDO> getProduceReportDetailListByReportId(Long reportId);
    List<ProduceReportDetailRespVO> getDetailListByReportId(Long reportId);
    void updateStatus(Long id, Integer status);

    List<ProduceReportDO> getList(ProduceReportPageReqVO pageReqVO);

    //汇总某人某段时间的报工成品废品数据
    ViewReportUserDateSummary selectSumBy(Long userId, String[]reportDays);
    List<ViewReportUserDateSummary> selectBy(Long userId, String reportDay, String[]reportDays);

}